# Mõned vähem tuntud nipid käsureal

Kiirklahvid:

* Ctrl-L - tühjenda ekraan
* Ctrl-R - ajaloost käskude otsimiseks regulaaravaldisega
* Ctrl-D - terminalist väljumiseks
* Ctrl-C - hetkel käivale protsessile katkestamise (SIGINT) signaali saatmiseks
* Ctrl-Z - hetkel käivale protsessile pausi (SIGSTOP) signaali saatmiseks
* Ctrl-Vasak, Ctrl-Parem - Sõna kaupa navigeerimine käsus
* Home, End - Käsu algusess või lõppu navigeerimine

# Käskude taustal käitamine

Käsu taustale panemiseks saab vajutada Ctrl-Z ning seejärel anda käsk

```
bg
```

Käsu taustal käima panemiseks võib käsu lõppu panna & sümboli,
tulemuste ja veateadete salvestamiseks tuleks stdout ja stderr ümber suunata:

```bash
käsk > /tmp/tulemused 2>/tmp/veateated &
```

See väljastab käivitatud protsessi identifikaatori (PID),
lisaks on käsu PID salvestatud keskkonnamuutujasse ```$!```

Selleks et kontrollida kas käsk toimetab veel kõige lihtsam:

```bash
test -e /proc/$! && echo "Käsk toimetab veel" || echo "Käsk on lõpetanud"
```

Selleks et näha mis käsud taustal toimetavad:

```bash
jobs
```

Selleks et taustal toimetava käsu külge haakida ja katkestada

```bash
fg 1 # Haagi esimese käsu külge
# Vajuta nüüd Ctrl-C et katkestada
```

# Copy-paste Ctrl-D abil

Faili copy-paste terminali abil saab teha järgnevalt.
Käivita käsk:

```bash
cat > failinimi
```

Käsk jääb ootama sisendit standardsisendist, st klaviatuur antud juhul.
Kopeeri lõik soovitud failist ning aseta PuTTY puhul parema hiireklõpsuga.
Vajuta Ctrl-D et lõpetada asetamine. Ctrl-D tähendab käsureal EOF-i (end of file).

# Copy-paste EOF markeriga

Käivita käsk:

```bash
cat << EOF > failinimi
```

Aseta soovitud sisu ning lõpetamiseks kirjuta EOF ning vajuta enter.

Siinkohal bash asendab $MUUTUJAD.

Kui soovid copy-paste sooritada nii et bash ei asendaks muutujaid:

```bash
cat << \EOF > failinimi
```

Aseta sisu, kirjuta EOF ning vajuta Enter

# Failide loomine käsuga

Juhendite kirjutamisel tuleb abiks kui terve käsk koos sisuga on kopeeritav:

```bash
cat << \EOF > failinimi
See on faili sisu
EOF
```
